/* os.S
 *  
 */

#include "pm.h"

.code16
.text
	jmp os_main

# Segment descritors for GDT
LABEL_GDT_NULL: 	SEG_DESC 		0, 					0, 					0
LABEL_GDT_CODE: 	SEG_DESC 		0, 	(PECode32Len - 1), \
										(DESC_ATTR_TYPE_CD_E | DESC_ATTR_D)
LABEL_GDT_DATA: 	SEG_DESC 		0, 		(DataLen - 1), \
										 			  (DESC_ATTR_TYPE_CD_RW)  
LABEL_GDT_STACK_R0: SEG_DESC 		0, 		 TopOfStackR0, \
			   				 (DESC_ATTR_TYPE_CD_RWA | DESC_ATTR_D | DA_DPL0) 
LABEL_GDT_TSS: 		SEG_DESC 		0, 		 (TSSLen - 1), \
									 					(DESC_ATTR_TYPE_TSS)
LABEL_GDT_VIDEO: 	SEG_DESC  0xB8000, 			   0xFFFF, \
										      (DESC_ATTR_TYPE_CD_RW | DA_DPL3) 
LABEL_GDT_LDT: 		SEG_DESC 		0, 		 (LDTLen - 1), \
														(DESC_ATTR_TYPE_LDT) 
LABEL_GDT_CODE_R3: 	SEG_DESC 		0, 	  (CODER3Len - 1), \
				 			  (DESC_ATTR_TYPE_CD_E | DESC_ATTR_D | DA_DPL3) 
LABEL_GDT_STACK_R3: SEG_DESC 		0, 		 TopOfStackR3, \
				    		 (DESC_ATTR_TYPE_CD_RWA | DESC_ATTR_D | DA_DPL3) 
LABEL_GDT_DATA_R3: 	SEG_DESC 		0, 		(DataLenR3 - 1), \
								 			  (DESC_ATTR_TYPE_CD_RW + DA_DPL3)  
LABEL_GDT_CG_CODE: 	SEG_DESC		0,(CG_CODE32_LEN - 1), \
					 		 			(DESC_ATTR_TYPE_CD_E | DESC_ATTR_D) 


LABEL_GDT_CG: 		CALL_GATE		SegSelectorCGCODE, 0, 0, 	(GATE_CG_ATTR | DA_DPL3) 

# The length of GDT
.set GdtLen, (. - LABEL_GDT_NULL)

# Segment selectors
.set SegSelectorCode32, (LABEL_GDT_CODE 	- LABEL_GDT_NULL)
.set SegSelectorData, 	(LABEL_GDT_DATA 	- LABEL_GDT_NULL)
.set SegSelectorStackR0,(LABEL_GDT_STACK_R0 - LABEL_GDT_NULL)
.set SegSelectorTSS, 	(LABEL_GDT_TSS 		- LABEL_GDT_NULL)
.set SegSelectorVideo, 	(LABEL_GDT_VIDEO 	- LABEL_GDT_NULL)
.set SegSelectorLDT, 	(LABEL_GDT_LDT 		- LABEL_GDT_NULL)
.set SegSelectorCodeR3,	(LABEL_GDT_CODE_R3 	- LABEL_GDT_NULL + SA_RPL3)
.set SegSelectorStackR3,(LABEL_GDT_STACK_R3 - LABEL_GDT_NULL + SA_RPL3)
.set SegSelectorDataR3,	(LABEL_GDT_DATA_R3 	- LABEL_GDT_NULL + SA_RPL3)
.set SegSelectorCGCODE,	(LABEL_GDT_CG_CODE 	- LABEL_GDT_NULL)
.set SegSelectorCG, 	(LABEL_GDT_CG 		- LABEL_GDT_NULL + SA_RPL3)

# data segment 
LABEL_DATA:
Msg1: 	.ascii "Welcome to kernel mode (Ring 0) in GDT.\0"
Msg2: 	.ascii "Welcome to kernel mode (Ring 0) in LDT.\0"
Msg3: 	.ascii "Welcome to kernel mode through Call Gate (Ring 3 -> Ring 0).\0"

.set 	Msg1Offset, (Msg1 - LABEL_DATA)
.set 	Msg2Offset, (Msg2 - LABEL_DATA)
.set 	Msg3Offset, (Msg3 - LABEL_DATA)

.set DataLen, (. - LABEL_DATA)

LABEL_DATA_R3:
Msg1_R3: 	.ascii "Welcome to user mode (Ring 3).\0"

.set 	Msg1OffsetR3, (Msg1_R3 - LABEL_DATA_R3)

.set DataLenR3, (. - LABEL_DATA_R3)


# GDTR pointer
LABEL_GDTR: 
	.2byte (GdtLen - 1) 	# Limit field
	.4byte 0 				# base field

# LDT information
LABEL_LDT:
LABEL_LDT_ENTRY: SEG_DESC 0, (LDT_CODE32_LEN - 1), (DESC_ATTR_TYPE_CD_E | DESC_ATTR_D)

# length of LDT
.set LDTLen, (. - LABEL_LDT)

# LDT selector
.set SegSelectorLDTCode32, 	(LABEL_LDT_ENTRY - LABEL_LDT + SA_TIL)

.align 4
LABEL_STACKR0:
.space 	512, 0
.set TopOfStackR0, (. - LABEL_STACKR0)

LABEL_STACKR3: 
.space	512, 0
.set TopOfStackR3, (. - LABEL_STACKR3)

LABEL_TSS:
	.4byte 	0 						/* Previous Task Link 	*/
	.4byte 	TopOfStackR0 	 		/* ESP0 				*/
	.4byte  SegSelectorStackR0 	 	/* SS0 					*/
	.4byte  0 						/* ESP1 				*/
	.4byte  0                       /* SS1 					*/
	.4byte  0 						/* ESP2 				*/
	.4byte  0                       /* SS2 					*/
	.4byte  0 						/* CR3 (PDBR) 			*/
	.4byte  0 						/* EIP 					*/
	.4byte  0 						/* EFLAGS 				*/
	.4byte  0 						/* EAX 					*/
	.4byte  0 						/* ECX 					*/
	.4byte  0 						/* EDX 					*/
	.4byte  0 						/* EBX 					*/
	.4byte  0 						/* ESP 					*/
	.4byte  0 						/* EBP 					*/
	.4byte  0 						/* ESI 					*/
	.4byte  0 						/* EDI 					*/
	.4byte  0 						/* ES 					*/
	.4byte  0 						/* CS 					*/
	.4byte  0 						/* SS 					*/
	.4byte  0 						/* DS 					*/
	.4byte  0 						/* FS 					*/
	.4byte  0 						/* GS 					*/
	.4byte  0 						/* LDT Segment Selector	*/
	.2byte  0 						/* Reserved				*/
    .2byte  (. - LABEL_TSS + 2)     /* I/O Map Base Address */
.set TSSLen, (. - LABEL_TSS) 

# real-mode OS code
os_main:
	mov %cs, %ax
	mov %ax, %ds
	mov %ax, %ss
	mov %ax, %es

    mov     $0x100, %sp

	/* Set gdt for code segment */
	InitSegDescriptor LABEL_PE_CODE32, LABEL_GDT_CODE
	InitSegDescriptor LABEL_DATA, LABEL_GDT_DATA
	InitSegDescriptor LABEL_TSS, LABEL_GDT_TSS
	InitSegDescriptor LABEL_LDT, LABEL_GDT_LDT
	InitSegDescriptor LABEL_STACKR0, LABEL_GDT_STACK_R0
	InitSegDescriptor LABEL_PE_LDT_CODE32, LABEL_LDT_ENTRY
	InitSegDescriptor LABEL_PE_CG_CODE32, LABEL_GDT_CG_CODE
	InitSegDescriptor LABEL_CODE_R3, LABEL_GDT_CODE_R3
	InitSegDescriptor LABEL_STACKR3, LABEL_GDT_STACK_R3
	InitSegDescriptor LABEL_DATA_R3, LABEL_GDT_DATA_R3

	/* Set GDTR */
	xor 	%ax, %ax
	mov 	%cs, %ax
	shl 	$4, %eax
	addl    $LABEL_GDT_NULL, %eax
	movl 	%eax, (LABEL_GDTR + 2)				

	/* Enable A20 line */
	xor 	%ax, %ax
	in 		$0x92, %al
	or 		$2, %al
	out 	%al, $0x92

	cli

	/* Load the GDT base address and limit from memory into the GDTR register */
	lgdt 	LABEL_GDTR

 	/* Enable protect mode */
	movl 	%cr0, %eax
	orl 	$1, %eax
	movl 	%eax, %cr0

	/* Jump to protected-mode OS code */
	ljmpl 	$SegSelectorCode32, $0

LABEL_PE_CG_CODE32:
.code32
	mov 	$(SegSelectorData), %ax
	mov 	%ax, %ds
	mov 	$(SegSelectorVideo), %ax
	mov 	%ax, %gs

	xorl 	%esi, %esi
	xorl    %edi, %edi
	movl 	$Msg3Offset, %esi
	movl 	$((80 * 13 + 0) * 2), %edi
	movb 	$0xC, %ah

cg_dump_str:
	lodsb
	andb 	%al, %al
	jz  	cg_fin
	mov 	%ax, %gs:(%edi)	
	addl 	$2, %edi
	jmp 	cg_dump_str

cg_fin:
	lret	

.set CG_CODE32_LEN, (. - LABEL_PE_CG_CODE32)

LABEL_PE_LDT_CODE32:
.code32
	mov 	$(SegSelectorData), %ax
	mov 	%ax, %ds
	mov 	$(SegSelectorVideo), %ax
	mov 	%ax, %gs


	xorl 	%esi, %esi
	xorl    %edi, %edi
	movl 	$Msg2Offset, %esi
	movl 	$((80 * 11 + 0) * 2), %edi
	movb 	$0xC, %ah

ldt_dump_str:
	lodsb
	andb 	%al, %al
	jz  	ldt_fin
	mov 	%ax, %gs:(%edi)	
	addl 	$2, %edi
	jmp 	ldt_dump_str

ldt_fin:
	lret 

.set LDT_CODE32_LEN, (. - LABEL_PE_LDT_CODE32)

# protected-mode OS code in GDT
LABEL_PE_CODE32:
.code32	
	/* Load data segment selector */
	mov 	$(SegSelectorData), %ax
	mov 	%ax, %ds

	mov 	$(SegSelectorStackR0), %ax
	mov 	%ax, %ss

	/* Load Video segment selector */
	mov 	$(SegSelectorVideo), %ax
	mov 	%ax, %gs

	mov     $(TopOfStackR0), %esp

	/* Output the data */
	xorl 	%esi, %esi
	xorl    %edi, %edi
	movl 	$Msg1Offset, %esi
	movl 	$((80 * 10 + 0) * 2), %edi
	movb 	$0xC, %ah

dump_str:
	lodsb
	andb 	%al, %al
	jz  	fin
	mov 	%ax, %gs:(%edi)	
	addl 	$2, %edi
	jmp 	dump_str
fin:

	/* Load LDT selector */
	mov 	$(SegSelectorLDT), %ax
	
	/* Load LDT selector in GDT to LDT register */
	lldt 	%ax

	/* Jump to code segment in LDT */
	lcall 	$(SegSelectorLDTCode32), $0

	mov 	$(SegSelectorTSS), %ax
	ltr 	%ax


	pushl	$(SegSelectorStackR3)
	pushl 	$(TopOfStackR3)
	pushl 	$(SegSelectorCodeR3)
	pushl 	$0
	lret

	#jmp .

	
.set PECode32Len, (. - LABEL_PE_CODE32)
		
LABEL_CODE_R3:
	/* Load data segment selector */
	mov 	$(SegSelectorDataR3), %ax
	mov 	%ax, %ds

	/* Load Video segment selector */
	mov 	$(SegSelectorVideo), %ax
	mov 	%ax, %gs

	/* Output the data */
	xorl 	%esi, %esi
	xorl    %edi, %edi
	movl 	$Msg1OffsetR3, %esi
	movl 	$((80 * 12 + 0) * 2), %edi
	movb 	$0xC, %ah

dump_str_r3:
	lodsb
	andb 	%al, %al
	jz  	fin_r3
	mov 	%ax, %gs:(%edi)	
	addl 	$2, %edi
	jmp 	dump_str_r3
fin_r3:
	lcall   $(SegSelectorCG), $0
    jmp     .

.set CODER3Len, (. - LABEL_CODE_R3)

	.ascii "Welcome to OS context!"
	.byte 	0	

    .org    0xA00, 0x41 # fill characters with 'A'. Sector 2
	
